-- "true" means enabled, "false" means disabled
sFilter_Settings = {
    configmode = false, -- In this mode all icons are shown and can be moved.
    FontSize = 17,      -- Font size for stacks text
    r = .8,             -- Text color for stacks text More info: http://www.wowwiki.com/API_FontString_SetTextColor
    g = .8,
    b = .8,
    CountPoint = {"BOTTOMRIGHT"},            -- Stacks text position. More info: http://www.wowwiki.com/API_Region_SetPoint
}

--[[ More info about config mode:
You can move icons with left mouse button while holding Alt OR Shift. Changed position won't be saved between sessions.
After click on icon you will see in chat info about its position. This can be used to change setPoint attribute is spell list.
Clicking on icon with right mouse button will reset its position to default.
]]

--[[ Closer look at spell lists:
All classes have their own spell list.
Each entry in list creates a separate icon. Entry is a table with values in it:
- spellId - id of spell you want to track. If you don't know it - check wowhead.com - last number in any spell link is spellid (example: http://www.wowhead.com/?spell=55095, id is 55095)
- spellId2, spellId3, spellId4, spellId5 - optional entries, these are the spellids you want to track if primary spell is NOT active.
- size - icon size in pixels
- unitId - unit at which you wish to track selected spell(s). More info: http://www.wowwiki.com/UnitId
- isMine - this is filter. isMine = 1 means only  effects from units in MyUnits table will be shown (see below for this table. Note: isMine = "1" will NOT work, it should be number, not string. Any other value will show effect from any source
- filter - filter again =). Needs to be "HELPFUL" for buffs and "HARMFUL" for debuffs.
- setPoint - where to place the icon. It's a table with coordinates inside. More info: http://www.wowwiki.com/API_Region_SetPoint

I removed alpha settings and some other things, you can use original addon version for these features: http://toxila.googlecode.com/svn/zips/sFilter/
]]

sFilter_Spells = {
    ["DEATHKNIGHT"] = {
	-- Armor Debuff: Sunder Armor - Expose Armor
    {spellId = 7386, spellId2 = 770, spellId3 = 8647, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, 0}},
	
	
    -- Attack Speed Debuff: Thunder Clap - Infected Wounds - Judgements of the Just
    {spellId = 6343, spellId2 = 48484, spellId3 = 53696, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, -30}},
	-- Attack Speed Debuff: Waylay - Frost Fever - Earth Shock
    {spellId = 51696, spellId2 = 59921, spellId3 = 8042, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, -30}},
	
	
    -- Attack Power Debuff: Demoralizing Shout - Demoralizing Roar - Vindication
    {spellId = 1160, spellId2 = 99, spellId3 = 26016, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, -60}},
	-- Attack Power Debuff: Scarlet Fever - Curse of Weakness
    {spellId = 81132, spellId2 = 702, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, -60}},
    },
	
    ["DRUID"] = { 
	-- Lacerate
	{spellId = 33745, size = 24, unitId = "target", isMine = 1, filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", -70, -45}},
	-- Pulverize
	{spellId = 80313, size = 24, unitId = "player", isMine = 1, filter = "HELPFUL", setPoint = {"CENTER", UIParent, "CENTER", -70, -10}},
	
	-- Armor Debuff: Sunder Armor - Expose Armor
    {spellId = 7386, spellId2 = 770, spellId3 = 8647, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, 0}},
	
	
    -- Attack Speed Debuff: Thunder Clap - Infected Wounds - Judgements of the Just
    {spellId = 6343, spellId2 = 48484, spellId3 = 53696, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, -30}},
	-- Attack Speed Debuff: Waylay - Frost Fever - Earth Shock
    {spellId = 51696, spellId2 = 59921, spellId3 = 8042, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, -30}},
	
	
    -- Attack Power Debuff: Demoralizing Shout - Demoralizing Roar - Vindication
    {spellId = 1160, spellId2 = 99, spellId3 = 26016, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, -60}},
	-- Attack Power Debuff: Scarlet Fever - Curse of Weakness
    {spellId = 81132, spellId2 = 702, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, -60}},	
    },
	
    ["HUNTER"] = {
    },
	
    ["MAGE"] = {
    },
	
    ["PALADIN"] = {
	-- Armor Debuff: Sunder Armor - Expose Armor
    {spellId = 7386, spellId2 = 770, spellId3 = 8647, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, 0}},
	
	
    -- Attack Speed Debuff: Thunder Clap - Infected Wounds - Judgements of the Just
    {spellId = 6343, spellId2 = 48484, spellId3 = 53696, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, -30}},
	-- Attack Speed Debuff: Waylay - Frost Fever - Earth Shock
    {spellId = 51696, spellId2 = 59921, spellId3 = 8042, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, -30}},
	
	
    -- Attack Power Debuff: Demoralizing Shout - Demoralizing Roar - Vindication
    {spellId = 1160, spellId2 = 99, spellId3 = 26016, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, -60}},
	-- Attack Power Debuff: Scarlet Fever - Curse of Weakness
    {spellId = 81132, spellId2 = 702, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, -60}},
    },
	
    ["PRIEST"] = {
    },
	
    ["ROGUE"] = {
	-- Slice and Dice
	{spellId = 5171, size = 24, unitId = "player", isMine = 1, filter = "HELPFUL", setPoint = {"CENTER", UIParent, "CENTER", -70, -10}},
    },
	
    ["SHAMAN"] = {
	-- Shields
    {spellId = 52127, spellId2 = 324, size = 24, unitId = "player", isMine = 1, filter = "HELPFUL", setPoint = {"CENTER", UIParent, "CENTER", -70, -10}},
    },
	
    ["WARLOCK"] = {
	},
	
    ["WARRIOR"] = {    
	-- HAMSTRING / HOWL
	{spellId = 1715, spellId2 = 12323, size = 24, unitId = "target", isMine = 1, filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", -80, -0}},
	-- MORTAL STRIKE
	{spellId = 12294, size = 24, unitId = "target", isMine = 1, filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", -80, -30}},
	-- REND
	{spellId = 772, size = 24, unitId = "target", isMine = 1, filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", -80, -60}},
	-- TASTE FOR BLOOD
	{spellId = 60503, size = 24, unitId = "player", isMine = 1, filter = "HELPFUL", setPoint = {"CENTER", UIParent, "CENTER", -80, 30}},
	
    -- Armor Debuff: Sunder Armor - Expose Armor
    {spellId = 7386, spellId2 = 770, spellId3 = 8647, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, 0}},
	
	
    -- Attack Speed Debuff: Thunder Clap - Infected Wounds - Judgements of the Just
    {spellId = 6343, spellId2 = 48484, spellId3 = 53696, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, -30}},
	-- Attack Speed Debuff: Waylay - Frost Fever - Earth Shock
    {spellId = 51696, spellId2 = 59921, spellId3 = 8042, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, -30}},
	
	
    -- Attack Power Debuff: Demoralizing Shout - Demoralizing Roar - Vindication
    {spellId = 1160, spellId2 = 99, spellId3 = 26016, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, -60}},
	-- Attack Power Debuff: Scarlet Fever - Curse of Weakness
    {spellId = 81132, spellId2 = 702, size = 24, unitId = "target", isMine = "all", filter = "HARMFUL", setPoint = {"CENTER", UIParent, "CENTER", 80, -60}},
    }
}